--hey! quit sneaking around in here!

SIMPLER_ANIMAL_SETUP("peppinobutcool", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "JOGG", "CAZY", "LAND", "DVBM", "SKDD", "DRLF", "DRRF", "TAUN",
"SJPR", "SJGO", "SJCS", "SJCA", "GRAA", "GRAB", "GRAC", "GRBI", "GRBF", "GRBW", "PUNA", "PUNB", "PUNC", "PUND", "PUNE", "PUNF", "UPCE", "UPCB", "SWIM", "ASPN", "BSPN",
"LOJU")-- Initiate character and custom Sprite2s.
SIMPLER_ANIMAL_SETUP("thenoisebutcool", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "JOGG", "CAZY", "LAND", "DVBM", "SKDD", "DRLF", "DRRF", "TAUN",
"SJPR", "SJGO", "SJCS", "SJCA", "GRAA", "GRAB", "GRAC", "GRBI", "GRBF", "GRBW", "PUNA", "PUNB", "PUNC", "PUND", "PUNE", "PUNF", "UPCE", "UPCB", "SWIM", "ASPN", "BSPN")

freeslot("sfx_mach1", "sfx_mach2", "sfx_mach3", "sfx_mach4", "sfx_taunt", "MT_TAUNTEFFECTTHINGY", "MT_WALLCHECKER", "S_TAUNTBUBBBLE", "S_PIZZAFACE", "SPR_PIZF", "SPR_TANT", "sfx_upcut")

CV_RegisterVar({name = "PT_Jump",
				description = "Allows Peppino or The Noise to jump",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Superjump",
				description = "Allows Peppino or The Noise to superjump",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Taunt",
				description = "Allows Peppino or The Noise to taunt",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Grab",
				description = "Allows Peppino or The Noise to grab",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Uppercut",
				description = "Allows Peppino or The Noise to uppercut",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Wallbounce",
				description = "Allows The Noise to wallbounce",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_Wallspin",
				description = "Allows The Noise to wallspin after a wallbounce",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})
CV_RegisterVar({name = "PT_NoiseCrusher",
				description = "Allows The Noise to use his Noise Crusher",
				defaultvalue = "On",
				flags = CV_NETVAR,
				PossibleValue = CV_OnOff})

mobjinfo[MT_TAUNTEFFECTTHINGY] = {
	doomednum = -1,
	spawnstate = S_TAUNTBUBBBLE,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}
mobjinfo[MT_WALLCHECKER] = {
	doomednum = -1,
	spawnstate = S_TAUNTBUBBBLE,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP
}
states[S_TAUNTBUBBBLE] = {
	sprite = SPR_TANT,
	frame = FF_ANIMATE,
	tics = 18,
	var1 = 8,
	var2 = 2,
	nextstate = S_INVISIBLE,
}
states[S_PIZZAFACE] = {
	sprite = SPR_PIZF,
	frame = FF_ANIMATE,
	tics = -1,
	var1 = 15,
	var2 = 2,
	nextstate = S_PIZZAFACE,
}

addHook("PlayerSpawn", function(ptluas) 
    if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
        ptluas.therealtaunttimer = 20
        ptluas.therealsuperjumpprepgoingup = 20
        ptluas.tauntcooldown = 12
        ptluas.sjumpcanceltimer = 20
        ptluas.throwcooldown = 10
        ptluas.grabbingtimer = 40
        ptluas.grabcooldown = 40
        ptluas.hittimer = 10
        ptluas.uppercutanimtimer = 0
        ptluas.escapevalue = 0
		ptluas.noiseairspintimer = 5
		ptluas.noisecrushertimer = 8
		ptluas.doublejumptimer = 10
		ptluas.wallsticktimer = 20
		ptluas.ljtimer = 13
		ptluas.grabtype = 0

        -- Movement & Momentum
        ptluas.prevmomx = 0
        ptluas.prevmomy = 0
        ptluas.prevmomz = 0
		ptluas.wallclimbspeed = 0
        ptluas.dx = 0
        ptluas.dy = 0
        ptluas.thezvalue = 15 * ptluas.mo.scale

        -- States
        ptluas.istaunting = false
        ptluas.victimgotgrabbed = false
        ptluas.issuperjumpprepping = false
        ptluas.issuperjumping = false
        ptluas.issuperjumpcancel = false
        ptluas.dothatanimation = false
        ptluas.ispunching = false
        ptluas.ispunchinganim = false
        ptluas.isgrabbing = false
        ptluas.isjumping = false
        ptluas.isuppercutting = false
        ptluas.aircontrol = false
		ptluas.climbing = false
		ptluas.wasclimbing = false
		ptluas.longjumping = false

        -- Permissions
        ptluas.canyousuperjump = true
        ptluas.canyoutaunt = true
        ptluas.canyougrab = true
        ptluas.canyoujump = true
        ptluas.canyouuppercut = true
		ptluas.canyouwallrun = true

        -- Randomized Values
        ptluas.thetaunt = P_RandomRange(1, 10)
        ptluas.thepunch = P_RandomRange(1, 5)

        -- Grabbing Mechanics
        ptluas.grabspeedy = 0
        ptluas.tingus = 0
        ptluas.pingus = 0
        ptluas.victimgotgrabbed = false
        ptluas.grabbedvictim = nil
        ptluas.grabber = nil
		ptluas.setthethingstotrue = false
        -- Player Direction
        ptluas.playerdirection = 0
        ptluas.xinfrontoftheplayer = 0
        ptluas.yinfrontoftheplayer = 0
    end
end)

local helpers = _G["SIMPLER_ANIMAL_HELPERS"]

function SIMPLER_ANIMAL_HOOKS.peppinobutcool_hook(mobj)
	if helpers.getSkin(mobj) == "peppinobutcool" then
		local player = helpers.getPlayer(mobj)
		local machtwospeed = (K_GetKartSpeed(player, false, true) * 10) / 20
		local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
		local machfourspeed = (K_GetKartSpeed(player, false, true) * 30) / 20
		local speedthreshold = player.mo.scale / 8
		for i = 0, 108 do
			S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
		end
		player.tauntcooldown = $ - 1
		player.grabcooldown = $ - 1
		player.hittimer = $ - 1
		player.uppercutanimtimer = $ - 1
		player.ljtimer = $ - 1
		if mobj.sprite2 == SPR2_GOAL then
			return
		elseif (mobj.sprite2 == SPR2_SPIN) then return "SPIN", A, A, B
		elseif (mobj.sprite2 == SPR2_DEAD) return "DEAD", A, A, C
		elseif player.climbing then return "SWIM", A, I, I
		elseif player.spindash then return "ROLL", A, A, L
		elseif player.rideroid or player.pullup or player.dlzrocket then return "FALL", A, A, C
		elseif player.istaunting and player.thetaunt == 1 then return "TAUN", A, A, A
		elseif player.istaunting and player.thetaunt == 2 then return "TAUN", B, B, B
		elseif player.istaunting and player.thetaunt == 3 then return "TAUN", C, C, C
		elseif player.istaunting and player.thetaunt == 4 then return "TAUN", D, D, D --This is so ass, there are better ways to do this
		elseif player.istaunting and player.thetaunt == 5 then return "TAUN", E, E, E
		elseif player.istaunting and player.thetaunt == 6 then return "TAUN", F, F, F
		elseif player.istaunting and player.thetaunt == 7 then return "TAUN", G, G, G
		elseif player.istaunting and player.thetaunt == 8 then return "TAUN", H, H, H
		elseif player.istaunting and player.thetaunt == 9 then return "TAUN", I, I, I
		elseif player.istaunting and player.thetaunt == 10 then return "TAUN", J, J, J
		elseif player.istaunting and player.thetaunt == 11 then return "TAUN", K, K, K
		elseif player.istaunting and player.thetaunt == 12 then return "TAUN", L, L, L
		elseif player.uppercutanimtimer >= 0 and player.isuppercutting then return "UPCE", A, U, U
		elseif player.uppercutanimtimer < 0 and player.isuppercutting then return "UPCB", A, A, A
		elseif player.longjumping and player.ljtimer > 0 then return "LOJU", A, M, M
		elseif player.longjumping and player.ljtimer <= 0 then return "LOJU", M, M, M
		elseif player.ispunchinganim and player.thepunch == 1 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNA", A, A, K
		elseif player.ispunchinganim and player.thepunch == 2 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNB", A, A, K
		elseif player.ispunchinganim and player.thepunch == 3 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNC", A, A, K
		elseif player.ispunchinganim and player.thepunch == 4 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUND", A, A, K
		elseif player.ispunchinganim and player.thepunch == 5 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNE", A, A, K
		elseif player.ispunchinganim and player.thepunch == 6 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNF", A, A, K
		elseif player.issuperjumpprepping then return "SJPR", A, S, S
		elseif player.issuperjumping or player.pingus == 1 then return "SJGO", A, A, H
		elseif player.issuperjumpcancel then return "SJCS", A, X, X
		elseif player.isgrabbing and player.grabbingtimer > 38 then return "GRAA", A, B, B
		elseif player.isgrabbing and player.grabbingtimer < 38 and player.grabbingtimer > 3 then return "GRAB", B, H, H
		elseif player.isgrabbing and player.grabbingtimer < 3 then return "GRAC", A, C, C
		elseif player.dothatanimation and helpers.isAirborne(mobj) then return "SJCA", A, A, D
		elseif player.victimgotgrabbed and helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBF", A, A, C
		elseif player.victimgotgrabbed and helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBW", A, A, J
		elseif player.victimgotgrabbed then
			helpers.SquaredSlow(mobj, -1)
			return "GRBI", A, A, F
		elseif player.respawn.timer then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif helpers.isTricking(mobj) and player.fastfall then
			return "DVBM", A, A, C
		elseif helpers.isTricking(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SKDD", A, A, C
		elseif player.fastfall and ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "LAND", A, A, C
		elseif player.fastfall then
			return "DVBM", A, A, H
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) and helpers.isAirborne(mobj) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLF", A, A, C
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", E, M, M
		elseif helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif ((player.speed >= machfourspeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "CAZY", A, A, H
		elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "FSTN", A, A, C
		elseif ((player.speed >= machtwospeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "JOGG", A, A, H
		elseif mobj.sprite2 == SPR2_SLWN then
			if helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "SLWN", A, A, L
			else -- Moving sideways/backwards.
				if helpers.isMovingBackward(mobj) then
					helpers.SquaredSlow(mobj, 1)
					return "SLWN", L, L, A
				end
			end
		elseif mobj.sprite2 == SPR2_STIL then return "STIN", A, A, T
		end
	end
end

function SIMPLER_ANIMAL_HOOKS.thenoisebutcool_hook(mobj)
	if helpers.getSkin(mobj) == "thenoisebutcool" then
		local player = helpers.getPlayer(mobj)
		local machtwospeed = (K_GetKartSpeed(player, false, true) * 10) / 20
		local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
		local machfourspeed = (K_GetKartSpeed(player, false, true) * 30) / 20
		local speedthreshold = player.mo.scale / 8
		for i = 0, 108 do
			S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
		end
		player.tauntcooldown = $ - 1
		player.grabcooldown = $ - 1
		player.hittimer = $ - 1
		player.noiseairspintimer = $ - 1
		player.uppercutanimtimer = $ - 1
		player.noisecrushertimer = $ - 1
		player.doublejumptimer = $ - 1
		if mobj.sprite2 == SPR2_GOAL then
			return
		elseif (mobj.sprite2 == SPR2_SPIN) then return "SPIN", A, A, B
		elseif (mobj.sprite2 == SPR2_DEAD) return "DEAD", A, A, C
		elseif player.spindash then return "SLWN", A, A, H
		elseif player.rideroid or player.pullup or player.dlzrocket then return "FALL", A, A, C
		elseif player.istaunting and player.thetaunt == 1 then return "TAUN", A, A, A
		elseif player.istaunting and player.thetaunt == 2 then return "TAUN", B, B, B
		elseif player.istaunting and player.thetaunt == 3 then return "TAUN", C, C, C
		elseif player.istaunting and player.thetaunt == 4 then return "TAUN", D, D, D --This is so ass, there are better ways to do this
		elseif player.istaunting and player.thetaunt == 5 then return "TAUN", E, E, E
		elseif player.istaunting and player.thetaunt == 6 then return "TAUN", F, F, F
		elseif player.istaunting and player.thetaunt == 7 then return "TAUN", G, G, G
		elseif player.istaunting and player.thetaunt == 8 then return "TAUN", H, H, H
		elseif player.istaunting and player.thetaunt == 9 then return "TAUN", I, I, I
		elseif player.istaunting and player.thetaunt == 10 then return "TAUN", J, J, J
		elseif player.uppercutanimtimer >= 0 and player.isuppercutting then return "UPCE", A, U, U
		elseif player.uppercutanimtimer < 0 and player.isuppercutting then return "UPCE", U, U, U
		elseif player.isnoisecrusher and player.noisecrushertimer > 0 then return "SJCS", A, H, H
		elseif player.isnoisecrusher and player.noisecrushertimer <= 0 then return "SJCA", A, A, C
		elseif player.noiseairspin and player.noiseairspintimer >= 0 then return "BSPN", A, E, E
		elseif player.noiseairspin and player.noiseairspintimer < 0 then return "ASPN", A, G, G
		elseif player.noisewallbounce then return "SWIM", A, J, J
		elseif player.ispunchinganim and player.thepunch == 1 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNA", A, A, K
		elseif player.ispunchinganim and player.thepunch == 2 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNB", A, A, K
		elseif player.ispunchinganim and player.thepunch == 3 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNC", A, A, K
		elseif player.ispunchinganim and player.thepunch == 4 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUND", A, A, K
		elseif player.ispunchinganim and player.thepunch == 5 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNE", A, A, K
		elseif player.ispunchinganim and player.thepunch == 6 then 
			helpers.SquaredSlow(mobj, -1) 
			return "PUNF", A, A, K
		elseif player.issuperjumpprepping then return "SJPR", A, S, S
		elseif player.issuperjumping then return "SJGO", A, A, D
		elseif player.isgrabbing and player.grabbingtimer > 38 then return "GRAA", A, B, B
		elseif player.isgrabbing and player.grabbingtimer < 38 and player.grabbingtimer > 3 then return "GRAB", A, G, G
		elseif player.isgrabbing and player.grabbingtimer < 3 then return "GRAC", A, C, C
		elseif player.victimgotgrabbed and helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBF", A, A, C
		elseif player.victimgotgrabbed and helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "GRBW", A, A, J
		elseif player.victimgotgrabbed then
			helpers.SquaredSlow(mobj, -1)
			return "GRBI", A, A, H
		elseif player.respawn.timer then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif helpers.isTricking(mobj) and player.fastfall then
			return "DVBM", A, A, C
		elseif helpers.isTricking(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "FALL", A, A, C
		elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SKDD", A, A, C
		elseif player.fastfall and ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "LAND", A, A, C
		elseif player.fastfall then
			return "LAND", A, A, C
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) and helpers.isAirborne(mobj) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", A, A, D
		elseif (mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN) then -- Slowable drift.
			helpers.SquaredSlow(mobj, -1)
			return "DRLN", A, A, D
		elseif helpers.isAirborne(mobj) then return "FALL", A, A, C
		elseif ((player.speed >= machfourspeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "CAZY", A, A, C
		elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "FSTN", A, A, C
		elseif ((player.speed >= machtwospeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
			helpers.SquaredSlow(mobj, -1)
			return "JOGG", A, A, F
		elseif mobj.sprite2 == SPR2_SLWN then
			if helpers.isMovingForward(mobj) then
				helpers.SquaredSlow(mobj, -1)
				return "SLWN", A, A, H
			else -- Moving sideways/backwards.
				if helpers.isMovingBackward(mobj) then
					helpers.SquaredSlow(mobj, 1)
					return "SLWN", H, H, A
				end
			end
		elseif mobj.sprite2 == SPR2_STIL then return "STIN", A, A, Q
		end
	end
end

addHook("PlayerThink", function(ptluas) -- hey you cant do that
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if ptluas.spinouttimer > 0 or ptluas.tumblebounces > 0 or ptluas.respawn.timer then
        ptluas.istaunting = false
        ptluas.victimgotgrabbed = false
        ptluas.issuperjumpprepping = false
        ptluas.issuperjumping = false
        ptluas.issuperjumpcancel = false
        ptluas.dothatanimation = false
        ptluas.ispunching = false
        ptluas.ispunchinganim = false
        ptluas.isgrabbing = false
        ptluas.isjumping = false
        ptluas.isuppercutting = false
        ptluas.aircontrol = false
		ptluas.noisewallbounce = false
		ptluas.noiseairspin = false
		ptluas.noisecrusher = false
		ptluas.climbing = false
		ptluas.wasclimbing = false
		ptluas.isstickflighting = false
		ptluas.isstickflightspin = false
		ptluas.isstickflightcancel = false
		ptluas.stickairswim = false
		ptluas.stickairspin = false
		ptluas.doublejumping = false
		ptluas.isstickingtowall = false
		ptluas.setthethingstotrue = false
        ptluas.canyousuperjump = false
        ptluas.canyoutaunt = false
        ptluas.canyougrab = false
        ptluas.canyoujump = false
        ptluas.canyouuppercut = false
		ptluas.canyoudothespin = false
		ptluas.canyouwallrun = false
		ptluas.canyoudoublejump = false
		end
		if ptluas.spinouttimer <= 0 and ptluas.tumblebounces <= 0 and not ptluas.respawn.timer and not ptluas.setthethingstotrue then
			ptluas.setthethingstotrue = true
			ptluas.canyousuperjump = true
			ptluas.canyoutaunt = true
			ptluas.canyougrab = true
			ptluas.canyoujump = true
			ptluas.canyouuppercut = true
			ptluas.canyoudothespin = true
			ptluas.canyouwallrun = true
			ptluas.canyoudoublejump = true
		end
	end
end)


addHook("PlayerThink", function(ptluas) -- this checks for if youre holding taunt
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAC) then
			ptluas.tappedinput = 1 
		else
			ptluas.tappedinput = 0
		end
	end
end)


addHook("PlayerThink", function(ptluas) -- the jump
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAA) and not (ptluas.cmd.buttons & BT_DRIFT) and P_IsObjectOnGround(ptluas.mo) and CV_FindVar("PT_Jump").value == 1 then -- this code makes you jump
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -16*ptluas.mo.scale
			else
				ptluas.mo.momz = 16*ptluas.mo.scale
			end
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- the wallbounce
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "thenoisebutcool" then
		if ptluas.spinouttimer <= 0 and ptluas.tumblebounces <= 0 and not ptluas.fastfall and not ptluas.respawn.timer and ptluas.mo.eflags & MFE_JUSTBOUNCEDWALL and not P_IsObjectOnGround(ptluas.mo) and not ptluas.isuppercutting and not ptluas.isnoisecrusher and CV_FindVar("PT_Wallbounce").value == 1 and not (ptluas.victimgotgrabbed and ptluas.grabbedvictim and ptluas.grabber and ptluas.grabber.valid and ptluas.grabbedvictim.valid) then -- this code makes you jump
			ptluas.noisewallbounce = true
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -24*ptluas.mo.scale
			else
				ptluas.mo.momz = 24*ptluas.mo.scale
			end
			ptluas.canyougrab = false
			ptluas.canyoudothespin = true
			ptluas.noiseairspin = false
			ptluas.isgrabbing = false
		end
		if P_IsObjectOnGround(ptluas.mo) then --this puts you back to normal and resets the realtaunt timer
			ptluas.canyoujump = true
			ptluas.canyougrab = true
			ptluas.noisewallbounce = false
			ptluas.canyoudothespin = false
			ptluas.noiseairspintimer = 5
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- the air spin
    if ptluas.mo == nil then return end
    if ptluas.mo.skin == "thenoisebutcool" then
        ptluas.playerdirection = ptluas.mo.angle
		if (ptluas.cmd.buttons & BT_LUAB) and ptluas.canyoudothespin and ptluas.noiseairspintimer < 0 and not ptluas.isuppercutting and CV_FindVar("PT_Wallspin").value == 1 then -- this code makes you jump
			ptluas.noiseairspintimer = 5
			ptluas.noiseairspin = true
			ptluas.canyougrab = false
			ptluas.canyoudothespin = false
			ptluas.canyoutaunt = true
		end
		if ptluas.noiseairspin then
			ptluas.isnoisecrusher = false
			ptluas.mo.momx = FixedMul(cos(ptluas.playerdirection), 32*ptluas.mo.scale)
			ptluas.mo.momy = FixedMul(sin(ptluas.playerdirection), 32*ptluas.mo.scale)
		end
		if P_IsObjectOnGround(ptluas.mo) then --this puts you back to normal and resets the realtaunt timer
			ptluas.canyoujump = true
			ptluas.noiseairspin = false
			ptluas.noisewallbounce = false
			ptluas.canyoudothespin = false
		end
		if ptluas.isuppercutting then --for some damn reason
			ptluas.noiseairspin = false
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- uppercutting
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAB) and ptluas.throwdir == 1 and not (ptluas.cmd.buttons & BT_DRIFT) and not ptluas.ispunchinganim and ptluas.canyouuppercut and CV_FindVar("PT_Uppercut").value == 1 then -- this code makes you jump
			ptluas.canyouuppercut = false
			if ptluas.mo.skin == "thenoisebutcool" then
				if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
					ptluas.mo.momz = -32*ptluas.mo.scale
				else
					ptluas.mo.momz = 32*ptluas.mo.scale
				end
			else
				if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
					ptluas.mo.momz = -24*ptluas.mo.scale
				else
					ptluas.mo.momz = 24*ptluas.mo.scale
				end
			end
			ptluas.uppercutanimtimer = 16
			ptluas.isuppercutting = true
		end
		if P_IsObjectOnGround(ptluas.mo) then --this puts you back to normal and resets the realtaunt timer
			ptluas.canyouuppercut = true
			ptluas.pingus = 0
			ptluas.isuppercutting = false
		end
		if ptluas.longjumping and P_IsObjectOnGround(ptluas.mo) then
			ptluas.longjumping = false
			ptluas.canyougrab = true
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- the taunt
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAC) and ptluas.tauntcooldown < 0 and ptluas.canyoutaunt and not ptluas.isuppercutting and CV_FindVar("PT_Taunt").value == 1 and not (ptluas.victimgotgrabbed and ptluas.grabbedvictim and ptluas.grabber and ptluas.grabber.valid and ptluas.grabbedvictim.valid) then -- i guess this randomizes the frames and stores your speed.
			if ptluas.mo.skin == "thenoisebutcool" then
				ptluas.thetaunt = P_RandomRange(1, 10)
			else
				ptluas.thetaunt = P_RandomRange(1, 12)
			end
			P_SpawnMobjFromMobj(ptluas.mo, 0, 0, 0, MT_TAUNTEFFECTTHINGY)
			ptluas.istaunting = true
			S_StartSound(ptluas.mo, sfx_taunt)
			ptluas.prevmomx = ptluas.mo.momx
			ptluas.prevmomy = ptluas.mo.momy
			ptluas.prevmomz = ptluas.mo.momz
			ptluas.canyougrab = false
			ptluas.canyousuperjump = false
			ptluas.canyoujump = false
			ptluas.canyouuppercut = false
			ptluas.canyouchangemoveset = true
		end
		if ptluas.istaunting and not ptluas.respawn.timer then -- the code checks if youre taunting or not i suppose. it also freezes you and makes you invincible
			ptluas.istaunting = true
			ptluas.tauntcooldown = 20
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			ptluas.mo.momz = 0
			ptluas.spinouttype = KSPIN_IFRAMES
			ptluas.flashing = 2
			ptluas.therealtaunttimer = $ - 1
		end
		if ptluas.therealtaunttimer <= 0 then --this puts you back to normal and resets the realtaunt timer
			ptluas.istaunting = false
			ptluas.mo.momx = ptluas.prevmomx
			ptluas.mo.momy = ptluas.prevmomy
			ptluas.mo.momz = ptluas.prevmomz
			ptluas.tauntcooldown = $ - 1
			ptluas.therealtaunttimer = 20
			ptluas.canyougrab = true
			ptluas.canyousuperjump = true
			ptluas.canyouuppercut = true
			ptluas.canyouchangemoveset = false
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- the superjump
	if ptluas.mo == nil then return end
	ptluas.playerdirection = ptluas.mo.angle
	if ptluas.mo.skin == "peppinobutcool" or ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAA) and not (ptluas.cmd.buttons & BT_DRIFT) and ptluas.throwdir == 1 and ptluas.canyousuperjump and P_IsObjectOnGround(ptluas.mo) and CV_FindVar("PT_Superjump").value == 1 then -- superjump start button
			ptluas.issuperjumpprepping = true
			if ptluas.mo.momx >= 0 then ptluas.mo.momx = $ - 1 end
			if ptluas.mo.momy >= 0 then ptluas.mo.momy = $ - 1 end
			if ptluas.mo.momz >= 0 then ptluas.mo.momz = $ - 1 end
			ptluas.sjumpcanceltimer = 20
			ptluas.canyoutaunt = false
			ptluas.canyougrab = false
			ptluas.canyoujump = false
			ptluas.canyouuppercut = false
		end
		if ptluas.issuperjumpprepping and not ptluas.respawn.timer then -- superjump pause
			ptluas.issuperjumpprepping = true
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			ptluas.mo.momz = 0
			ptluas.therealsuperjumpprepgoingup = $ - 1
		end
		if gametype == GT_BATTLE and ptluas.therealsuperjumpprepgoingup <= 0 then
			ptluas.issuperjumpprepping = false
			ptluas.therealsuperjumpprepgoingup = 20
			ptluas.pingus = 1
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -48*ptluas.mo.scale
			else
				ptluas.mo.momz = 48*ptluas.mo.scale
			end
			ptluas.issuperjumping = false
		end
		if ptluas.therealsuperjumpprepgoingup <= 0 then --this part makes you go upwards
			ptluas.issuperjumpprepping = false
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -32*ptluas.mo.scale
			else
				ptluas.mo.momz = 32*ptluas.mo.scale
			end
			ptluas.issuperjumping = true
		end
		if (ptluas.cmd.buttons & BT_DRIFT or ptluas.cmd.buttons & BT_BRAKE or ptluas.cmd.buttons & BT_LUAB) and ptluas.issuperjumping and not ptluas.issuperjumpcancel and ptluas.mo.skin == "thenoisebutcool" then --superjump cancel start for noise
			ptluas.issuperjumping = false
			ptluas.therealsuperjumpprepgoingup = 20
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -8*ptluas.mo.scale
			else
				ptluas.mo.momz = 8*ptluas.mo.scale
			end
			ptluas.noiseairspintimer = 5
			ptluas.noiseairspin = true
			ptluas.canyougrab = false
			ptluas.canyoudothespin = false
		end
		if (ptluas.cmd.buttons & BT_DRIFT or ptluas.cmd.buttons & BT_BRAKE or ptluas.cmd.buttons & BT_LUAB) and ptluas.issuperjumping and not ptluas.issuperjumpcancel then --superjump cancel start start
			ptluas.therealsuperjumpprepgoingup = 20
			ptluas.issuperjumping = false
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			ptluas.mo.momz = 0
			ptluas.issuperjumpcancel = true
		end
		if ptluas.issuperjumpcancel then --superjump cancel start
			ptluas.mo.momx = 0
			ptluas.mo.momy = 0
			ptluas.mo.momz = 0
			ptluas.sjumpcanceltimer = $ - 1
		end
		if ptluas.sjumpcanceltimer < 0 then --this is the superjump cancel fly off code
			ptluas.dothatanimation = true
			ptluas.mo.momx = FixedMul(cos(ptluas.playerdirection), 80*ptluas.mo.scale)
			ptluas.mo.momy = FixedMul(sin(ptluas.playerdirection), 80*ptluas.mo.scale)
			ptluas.mo.momz = FixedMul(sin(ptluas.mo.angle), 2*ptluas.mo.scale)
			ptluas.issuperjumpcancel = false
			ptluas.canyoujump = false
			ptluas.sjumpcanceltimer = 20
			ptluas.canyoutaunt = true
			ptluas.aircontrol = true
		end
		if ptluas.aircontrol and not ptluas.istaunting then
			ptluas.mo.momx = FixedMul(cos(ptluas.playerdirection), 80*ptluas.mo.scale)
			ptluas.mo.momy = FixedMul(sin(ptluas.playerdirection), 80*ptluas.mo.scale)
		end
		if ptluas.aircontrol and ptluas.mo.eflags & MFE_JUSTBOUNCEDWALL then
			ptluas.aircontrol = false
		end
		if ptluas.dothatanimation and P_IsObjectOnGround(ptluas.mo) then --this makes the player stop doing the superjump cancel animation when they touch the ground
			ptluas.dothatanimation = false
			ptluas.aircontrol = false
			ptluas.canyougrab = true
			ptluas.canyoutaunt = true
			ptluas.canyouuppercut = true
			ptluas.canyoujump = true
		end
	end
end)

addHook("PlayerThink", function(ptluas) -- noise crusher
	if ptluas.mo == nil then return end
	if ptluas.mo.skin == "thenoisebutcool" then
		if (ptluas.cmd.buttons & BT_LUAA) and not P_IsObjectOnGround(ptluas.mo) and ptluas.throwdir == 1 and not ptluas.isnoisecrusher and not ptluas.isuppercutting and not (ptluas.victimgotgrabbed and ptluas.grabbedvictim and ptluas.grabber and ptluas.grabber.valid and ptluas.grabbedvictim.valid) and not ptluas.isgrabbing and not ptluas.issuperjumping and CV_FindVar("PT_NoiseCrusher").value == 1 then -- this code makes you jump
			ptluas.isnoisecrusher = true
			ptluas.noiseairspin = false
			ptluas.noisecrushertimer = 8
			ptluas.canyoudothespin = true
			if (ptluas.mo.eflags & MFE_VERTICALFLIP) then
				ptluas.mo.momz = -32*ptluas.mo.scale
			else
				ptluas.mo.momz = 32*ptluas.mo.scale
			end
		end
		if P_IsObjectOnGround(ptluas.mo) then --this puts you back to normal and resets the realtaunt timer
			ptluas.isnoisecrusher = false
		end
	end
end)

addHook("PlayerThink", function(player) -- the hellish grab code
    if player.mo == nil then return end
    if player.mo.skin == "peppinobutcool" or player.mo.skin == "thenoisebutcool" then
        player.playerdirection = player.mo.angle
        if (player.cmd.buttons & BT_LUAB) and player.grabtype == 0 and player.throwdir != 1 and player.canyougrab and player.grabcooldown < 0 and not player.isuppercutting and CV_FindVar("PT_Grab").value == 1 then
            player.isgrabbing = true
			player.canyousuperjump = false
			player.canyoutaunt = false
            player.tingus = true
            player.throwcooldown = 10
            player.canyougrab = false
			if (player.mo.eflags & MFE_VERTICALFLIP) then
				player.thezvalue = -60*player.mo.scale
			else
				player.thezvalue = 60*player.mo.scale
			end
			
        end
        if player.tingus and R_PointToDist2(0, 0, player.mo.momx, player.mo.momy) < 24*player.mo.scale then
            player.mo.momx = FixedMul(cos(player.playerdirection), 24*player.mo.scale)
            player.mo.momy = FixedMul(sin(player.playerdirection), 24*player.mo.scale)
        end
        if player.isgrabbing and player.grabtype == 0 then
            player.grabbingtimer = $ - 1
			if (player.cmd.buttons & BT_LUAA) and not player.longjumping and P_IsObjectOnGround(player.mo) and player.grabtype == 0 then
				player.ljtimer = 13
				player.longjumping = true
				player.isgrabbing = false
				player.tingus = false
				player.grabcooldown = 40
				player.grabbingtimer = 40
				player.canyousuperjump = true
				player.canyoutaunt = true
			end

            for mobj in mobjs.iterate() do
				if mobj.valid and mobj.type == MT_PLAYER and mobj ~= player.mo and P_AproxDistance(mobj.x - player.mo.x, mobj.y - player.mo.y) <= 100*player.mo.scale then
					player.victimgotgrabbed = true
					player.grabbedvictim = mobj
					player.grabber = player.mo
					player.grabbedvictim.momx = 0
					player.grabbedvictim.momy = 0
					player.grabbedvictim.momz = 0
					player.grabbedvictim.player.canyougrab = false
					player.grabbedvictim.player.canyoujump = false
					player.grabbedvictim.player.canyousuperjump = false
					player.grabbedvictim.player.canyoutaunt = false
					player.grabbedvictim.player.canyouuppercut = false
					break
				end
			end
        end
        if player.grabbingtimer <= 0 or (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) or player.mo.eflags & MFE_JUSTBOUNCEDWALL then
            player.isgrabbing = false
            player.tingus = false
            player.grabcooldown = 40
            player.grabbingtimer = 40
            player.canyougrab = true
			player.canyousuperjump = true
			player.canyoutaunt = true
        end
        if (player.victimgotgrabbed and player.grabbedvictim and player.grabber and player.grabber.valid and player.grabbedvictim.valid) then
            player.canyougrab = false
			player.canyousuperjump = false
			player.canyoutaunt = false
			player.canyoudothespin = false
            player.grabbedvictim.momx = 0
            player.grabbedvictim.momy = 0
            player.grabbedvictim.momz = 0
            P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
            player.throwcooldown = $ - 1
            if (player.cmd.buttons & BT_LUAB) and player.throwcooldown <= 0 and not player.ispunching and player.throwdir != 1 then
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.thezvalue = -10
				else
					player.thezvalue = 10
				end
				player.thepunch = P_RandomRange(1, 5)
				player.xinfrontoftheplayer = FixedMul(cos(player.grabber.angle), 80*player.mo.scale)
				player.yinfrontoftheplayer = FixedMul(sin(player.grabber.angle), 80*player.mo.scale)
                P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
				player.ispunching = true
                player.hittimer = 40
                player.throwcooldown = 10
			elseif (player.cmd.buttons & BT_LUAB) and player.throwcooldown <= 0 and not player.ispunching and player.throwdir == 1 then
				player.thezvalue = 10
				player.thepunch = 6
				player.xinfrontoftheplayer = FixedMul(cos(player.grabber.angle), 80*player.mo.scale)
				player.yinfrontoftheplayer = FixedMul(sin(player.grabber.angle), 80*player.mo.scale)
                P_SetOrigin(player.grabbedvictim, player.grabber.x + player.xinfrontoftheplayer, player.grabber.y + player.yinfrontoftheplayer, player.grabber.z + player.thezvalue)
				player.ispunching = true
                player.hittimer = 40
                player.throwcooldown = 10
            end
			if (player.grabbedvictim.player.cmd.buttons & BT_ACCELERATE) and player.victimgotgrabbed then
				player.escapevalue = $ + 1
			end
            if player.hittimer > 0 and player.ispunching then
				player.grabber.momx = 0
				player.grabber.momy = 0
				player.grabber.momz = 0
				player.ispunchinganim = true
                if player.hittimer == 20 and player.thepunch <= 5 then
					player.grabbedvictim.player.canyougrab = true
					player.grabbedvictim.player.canyoujump = true
					player.grabbedvictim.player.canyousuperjump = true
					player.grabbedvictim.player.canyoutaunt = true
					player.grabbedvictim.player.canyouuppercut = true
                    P_DamageMobj(player.grabbedvictim, player.grabber, player.grabber, 1, DMG_NORMAL)
					player.grabbedvictim.momx = FixedMul(cos(player.grabber.angle), 32*player.mo.scale)
					player.grabbedvictim.momy = FixedMul(sin(player.grabber.angle), 32*player.mo.scale)
                    player.victimgotgrabbed = false
                    player.grabbedvictim = nil
                    player.grabber = nil
					player.xinfrontoftheplayer = 0
					player.yinfrontoftheplayer = 0
					player.escapevalue = 0
				elseif player.hittimer == 20 and player.thepunch == 6 then
					player.grabbedvictim.player.canyougrab = true
					player.grabbedvictim.player.canyoujump = true
					player.grabbedvictim.player.canyousuperjump = true
					player.grabbedvictim.player.canyoutaunt = true
					player.grabbedvictim.player.canyouuppercut = true
                    P_DamageMobj(player.grabbedvictim, player.grabber, player.grabber, 1, DMG_NORMAL)
					if (player.mo.eflags & MFE_VERTICALFLIP) then
						player.grabbedvictim.momz = -32 * player.mo.scale
					else
						player.grabbedvictim.momz = 32 * player.mo.scale
					end
                    player.victimgotgrabbed = false
                    player.grabbedvictim = nil
                    player.grabber = nil
					player.xinfrontoftheplayer = 0
					player.yinfrontoftheplayer = 0
					player.escapevalue = 0
                end
            end
            if player.spinouttimer > 0 or player.escapevalue == 40 then
				player.grabbedvictim.player.canyougrab = true
				player.grabbedvictim.player.canyoujump = true
				player.grabbedvictim.player.canyousuperjump = true
				player.grabbedvictim.player.canyoutaunt = true
				player.grabbedvictim.player.canyouuppercut = true
                player.grabbedvictim.momx = FixedMul(cos(player.grabbedvictim.angle), 64*player.mo.scale)
                player.grabbedvictim.momy = FixedMul(sin(player.grabbedvictim.angle), 64*player.mo.scale)
				if (player.mo.eflags & MFE_VERTICALFLIP) then
					player.grabbedvictim.momz = -16 * player.mo.scale
				else
					player.grabbedvictim.momz = 16 * player.mo.scale
				end
                player.grabcooldown = 40
                player.grabbingtimer = 0
                player.victimgotgrabbed = false
                player.grabbedvictim = nil
                player.grabber = nil
				player.canyougrab = true
				player.escapevalue = 0
            end
        else
            player.victimgotgrabbed = false
            player.grabbedvictim = nil
            player.grabber = nil
        end
    end
	if player.hittimer == 1 and player.ispunchinganim then
		player.ispunching = false
		player.ispunchinganim = false
		player.canyougrab = true
		player.canyousuperjump = true
		player.canyoutaunt = true
	end
end)

local spb_reskin = function(mo)
    if mo and mo.valid then
        if (mo.target and mo.target.skin == "peppinobutcool") or (mo.target and mo.target.skin == "thenoisebutcool") then
            if not mo.init then
                if mo.type == MT_SPB then
                    mo.state = S_PIZZAFACE
                end
                mo.init = true
            end
        end
    end
end

addHook("MobjThinker", spb_reskin, MT_SPB)